diff core/rc/rc.start @ 566:ddb052f876cd

core/rc: move etc services to rc, closes #1666
author David Demelier <markand@malikania.fr>
date Fri, 05 Jul 2019 20:58:54 +0200
parents core/etc/rc.start@79f1635bda5f
children dbd752e285f6
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/core/rc/rc.start	Fri Jul 05 20:58:54 2019 +0200
@@ -0,0 +1,47 @@
+#!/bin/sh
+#
+# /etc/rc.start: runlevel control script
+#
+# Copyright (c) 2019 David Demelier <markand@malikania.fr>
+#
+# Permission to use, copy, modify, and/or distribute this software for any
+# purpose with or without fee is hereby granted, provided that the above
+# copyright notice and this permission notice appear in all copies.
+#
+# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+#
+
+if [ "$#" -ne 1 ]; then
+	echo "usage: $0 runlevel" 1>&2
+	exit 1
+fi
+
+if [ -f /etc/rc.conf ]; then
+	source /etc/rc.conf
+fi
+
+# Start user services requested in rc.conf(5).
+for s in $SERVICES; do
+	#
+	# Services are requested in the form name[:runlevel], if runlevel is
+	# specified the service is started only if the system runlevel is
+	# greater or equal to the request.
+	#
+	name="${s%%:*}"
+	level="${s##*:}"
+
+	# No minimum level, set to requested.
+	if [ "$level" = "$name" ]; then
+		level="$1"
+	fi
+
+	if [ -x /etc/rc.d/$name ] && [ "$level" -le "$1" ]; then
+		/etc/rc.d/$name start
+	fi
+done